//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "DriverUSB.h"

void __fastcall OutSignalControl(UCHAR val);	//Gnrer les signaux de controles
void __fastcall SetOut();	//Ecrire des 1 sur le port pour permettre la lecture
long				lIn,lOut;		//Pointeur sur les diffrents buffers
long				lInSize,lOutSize;//Taille des diffrents buffers
unsigned long		lSize;		//
SECURITY_ATTRIBUTES	Security;	//
OVERLAPPED			gOverlapped;//Ncessaire pour les transmission asynchrone
HANDLE				HandlePort; //Handle du port crer
LPCTSTR				sFileName;	//Nom du fichier ncssaire pour l'ouverture du port
//---------------------------------------------------------------------------
/*	Fonction d'ouverture du port.
	Reoit : rien
    Fait : Ouvre le port de communication USB si le fichier spcifi est present sur
           sur le disque dur.
    Retourne : true si l'ouverture c'est bien passe, sinon elle retourne false.
*/
bool __fastcall OpenPort()
{
    //Nom du fichier pour le kit USBUART fourni par Elektor
	char * FileName="\\\\.\\usbuart_0";
	//ouvrir la ressource indique par le FileName
 	HandlePort=CreateFile(	FileName,GENERIC_READ|GENERIC_WRITE,0, NULL,
    						OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
	if(HandlePort==INVALID_HANDLE_VALUE) return false;
    return true;
}
//---------------------------------------------------------------------------
/*	Fonction de fermeture du port.
	Reoit : rien
    Fait : ferme le handle du port crer par OpenPort (CreateFile())
    Retourne : rien
*/
void __fastcall ClosePort()
{
	CloseHandle(HandlePort); //fermer le port
}
//---------------------------------------------------------------------------
/*	Fonction d'criture d'un octet sur le port
	Reoit : l'octet  crire
    Fait : calcul du pointeur de buffer d'entre en fonction de la valeur  crire
		pour le CYPRESS CY7C63001A.
    Retourne : rien
*/
void __fastcall OutPortUSB(UCHAR val)
{
    OutSignalControl(1);
    lIn = 65536 * val + 21;
  	lInSize = 3;
  	lOutSize = 1;
//prsenter l'octet a crire en entre des bascules D
	DeviceIoControl(HandlePort,(DWORD)4,&lIn,lInSize,&lOut,
    							lOutSize,&lSize, &gOverlapped);
//Gnrer le front permettant la memorisation de l'octet et son envoie sur les leds
	OutSignalControl(3),OutSignalControl(1);
}
//---------------------------------------------------------------------------
/*	Fonction d'criture d'un octet sur le port
	Reoit : rien
    Fait : Envois des 1 sur chaque bits du port pour permettre la lecture des
    	interrupteurs.
    Retourne : rien
*/
void __fastcall SetOut()
{
	lIn = 65536 * (0xFF) + 21;	//0xFF pour mettre les bits de l'octet  1
  	lInSize = 3;
  	lOutSize = 1;
	DeviceIoControl(HandlePort,(DWORD)4,&lIn,lInSize,&lOut,
    							lOutSize,&lSize, &gOverlapped);
}
//---------------------------------------------------------------------------
/*	Fonction de lecture d'un octet sur le port
	Reoit : rien
    Fait : envoie les signaux de control sur la carte puis lis les donnes prsente
    	sur le boitier
    Retourne : l'octet lu
*/
UCHAR __fastcall InPortUSB()
{
    SetOut();	//Mettre a 1 tous les bits du port avant la lecture
    OutSignalControl(0);//permettre la lecture des interrupteurs en envoyant un 0 a leur base
    lIn = 20;
  	lInSize=2;
  	lOutSize=2;
    //Commander l'interface (CY7C63001A) afin de lire le port
    DeviceIoControl(	HandlePort,(DWORD)4,&lIn,lInSize,&lOut,
    							lOutSize,&lSize, &gOverlapped);
    return (UCHAR)((lOut/256)&255);	//retourner
}
//---------------------------------------------------------------------------
/*	Fonction d'criture d'un octet sur le port 0 pour controle l'horloge des bascules
	et prendre en compte ou non l'tat des interrupteurs.
	Reoit : la valeur  crire (b0-> interrupteur,b1->horloge du 74HCT374)
    Fait : Ecrit sur le Port 0
    Retourne : rien
*/
void __fastcall OutSignalControl(UCHAR val)
{
	lIn = 65536 * val + 256 + 21;
    lInSize = 3;
    lOutSize = 1;
    DeviceIoControl(HandlePort,(DWORD)4,&lIn,lInSize,&lOut,
    							lOutSize,&lSize, &gOverlapped);
}
//---------------------------------------------------------------------------